=begin
/****************************************************************
**
** Implementation CannonField class, Qt tutorial 8
**
****************************************************************/
=end


class  CannonField < QWidget
attr_reader:angleChanged

def initialize ( parent, name )
    super( parent, name )
    @angleChanged = RSignal.new("int")
    @ang = 45
    setPalette( QPalette.new( QColor.new( 250, 250, 200,QColor::Rgb) ) )
    catchEvent
end


def setAngle( degrees )

    if ( degrees < 5 )
	degrees = 5
    elsif ( degrees > 70 )
	degrees = 70
    end
    if ( @ang == degrees )
	return
    end
    @ang = degrees
    repaintAll()
    @angleChanged.sendWith( @ang )
end


def paintEvent( ev )
    p = QPainter.new( self )

    p.setBrushQColor( Qt::blue )
    p.setPenPenStyle( Qt::NoPen )

    p.translate( 0, rect().bottom() )
    p.drawPieQRect( QRect.new(-35, -35, 70, 70), 0, 90*16 )
    p.rotate( -@ang )
    p.drawRectQRect( QRect.new(33, -4, 15, 8) )
end


def sizePolicy()
    QSizePolicy.new( QSizePolicy::Expanding, QSizePolicy::Expanding )
end

end
